<?php 
global $store_locator_map;
global $deleted_stores;

function custom_msf_get_categories() {
	watchdog('custom: mSF', 'custom_msf_get_categories', array(), WATCHDOG_DEBUG);
	$file_path  = variable_get('file_public_path', conf_path() . '/files/');
	global $base_url;
	global $base_path;
	
	$content = file_get_contents($base_url . '/shop/ajaxCategories.do');
	watchdog('custom: mSF', 'Categories: ' . $content, array(), WATCHDOG_DEBUG);

	$file = $file_path . "/msf/categories.json";
	$handleout = fopen($file, 'w'); // or die("custom: mSF -> custom_msf_get_categories can't open file: " . $file);

	if( $handleout !== FALSE ) {
		fwrite($handleout, $content);
		fclose($handleout);
		watchdog('custom: mSF', 'Categories loaded' . $content, array(), WATCHDOG_INFO);
	}
}

function custom_clean_and_load_storelocator_data($input, $clean_input, $chunks = -1) {
	custom_cleanup_store_locator_file($input, $chunks);
	custom_load_store_data($clean_input);
}

function custom_cleanup_store_locator_file($name, $chunks = -1) {
	watchdog('custom: Store Locator', 'custom_cleanup_store_locator_file(' . $name . ',' . $chunks . ')', array(), WATCHDOG_DEBUG);
	$file_path  = variable_get('file_public_path', conf_path() . '/files/');
    //$file_path = file_directory_temp();
	
	$filename = $file_path . '/storelocator/data_in/' . $name;
	$fileout = $file_path . "/storelocator/data_out/clean";
	$fileerr = $file_path . "/storelocator/error.log";
	$filearch = $file_path . "/storelocator/archive/";

	$keys = array();	//holds unique keys

	$handleerr = fopen($fileerr, 'w'); // or die("custom: Store Locator -> custom_cleanup_store_locator_file(): can't open file: " . $fileerr);

	if( $handleerr !== FALSE ) {
		$col_num = 14;	//number of columns expected
		$total_rows = $chunks; 	//max size of rows to output to a new file
		$header = 'id,name,address1,address2,city,state,zip,country,phone,email,website' . "\n";
	
		// open CSV file
		$row_num_total = 0;
		$row_num = 0;
		$err_num = 0;
		$file_num = 1;
		$file_name =  $fileout . '_' . ($chunks == -1 ? 'all' : $file_num) . '.csv';
		$handleout = fopen($file_name, 'w');
		fwrite($handleout, $header);
	
		if (($handle = fopen($filename, "r")) !== FALSE) {
			while (($data = fgetcsv($handle, 0, ",")) !== FALSE) {
				$row_num_total++;
				$row_num++;
				$id = $data[0];
				//$data[0] = $id;
				if( array_key_exists($id, $keys) ) {
					$err_num++;
					fwrite($handleerr, 'ERROR: Duplicate key on line: ' . $row_num_total . ', value of: ' . $id . ' => ' . implode(",",$data) . "\n");
				} else {
					$keys[$id] = $id;
				}
				$num = count($data);
				// check num of columns
				if($num < $col_num) {
					$err_num++;
					fwrite($handleerr, 'ERROR: Input line: ' . $row_num_total . ' has wrong number of columns (' . $num . ') => ' . implode(",",$data) . "\n");
				} else {
					$country = str_replace('"', '', $data[8]);
					if( strlen($country) > 2 ) {
						//check country code length
						$err_num++;
						fwrite($handleerr, 'ERROR: Country code (' . $country . ') length incorrect at line: ' . $row_num_total . ' => ' . implode(",",$data) . "\n");
					}else {
						// remove address 3
						unset($data[4]);
						$row = '';
						foreach ($data as $col) {
							// clean $col
							$clean = trim(str_replace('"', '\"', $col));
							if( $row == '' ) {
								$row .= '"' . $clean . '"';
							} else {
								$row .= ',"' . $clean . '"';
							}
						}
						$row .= "\n";
						fwrite($handleout, $row);
					}
				}
				if( $total_rows == $row_num ) {
					//break;
					fclose($handleout);
					$file_num++;
					$row_num = 0;
					$handleout = fopen($fileout . '_' . $file_num . '.csv', 'w') or die("can't open file: " . $fileout);
					fwrite($handleout, $header);
				}
					
			}
			fclose($handle);
			//archive file
			watchdog('custom: Store Locator', 'Files created: ' . $file_num . ', Errors found: ' . $err_num . ', total records processed: ' . $row_num_total, array(), WATCHDOG_INFO);
		}
	} else {
		watchdog("custom: Store Locator -> custom_cleanup_store_locator_file(): can't open file: " . $file_name, array(), WATCHDOG_ERROR);
	}

	fclose($handleout);
	fclose($handleerr);

	// create mapping file from db
	_custom_map_node_to_store();
}

function _custom_map_node_to_store() {
	$file_path  = variable_get('file_public_path', conf_path() . '/files/');
    //$file_path = file_directory_temp();
	$filename = $file_path . '/storelocator/storelocator.map';
	$handleout = fopen($filename, 'w');// or die("can't open file: " . $filename);

	$store_locator_map = array();
	
	if( $handleout !== FALSE ) {
		// load all store locator nodes
		$result = db_query("SELECT entity_id, field_store_number_value FROM field_data_field_store_number WHERE bundle = 'store_location'");
	
		while ($obj = $result->fetchAssoc()) {
			$store_locator_map[intval($obj['field_store_number_value'])] = $obj['entity_id'];
			$row = intval($obj['field_store_number_value']) . ',' . $obj['entity_id'] . "\n";
			fwrite($handleout, $row);
		}
	
		fclose($handleout);
	} else {
		watchdog("custom: Store Locator -> _custom_map_node_to_store(): can't open file: " . $file_name, array(), WATCHDOG_ERROR);
	}
	return $store_locator_map;
}

function custom_fix_store_id() {
	$file_path  = variable_get('file_public_path', conf_path() . '/files/');
	//$file_path = file_directory_temp();
	$filename = $file_path . '/storelocator/storelocator-node-cleanup.txt';
	$handleout = fopen($filename, 'w') or die("can't open file: " . $filename);

	// load all store locator nodes
	$result = db_query("SELECT entity_id, field_store_number_value FROM field_data_field_store_number WHERE bundle = 'store_location'");

	$store_locator_map = array();
	$num_fixed = 0;
	$total = 0;

	$nodes = array();
	
	while ($obj = $result->fetchAssoc()) {
		//load node if id is less than 6 digits
		$storeId = $obj['field_store_number_value'];
		$nid = $obj['entity_id'];
		if( strlen($storeId) < 8 ) {
			$nodes[] = $nid;
		}
		$total++;
	}
	
	foreach ($nodes as $nid) {
		$num_fixed++;
		node_delete($nid);
		fwrite($handleout, $num_fixed . ': Store Id for node -> ' . $nid . ' is bad ' . "\n");	
	}
	fwrite($handleout, 'Number of nodes deleted -> ' . $num_fixed . ' Total nodes -> ' . $total);
	watchdog('custom: Store Locator', 'custom_fix_store_id() => Number of nodes deleted -> ' . $num_fixed, array(), WATCHDOG_DEBUG);
	
	fclose($handleout);
}

function custom_store_id_status() {
	$file_path  = variable_get('file_public_path', conf_path() . '/files/');
    //$file_path = file_directory_temp();
	$filename = $file_path . '/storelocator/storelocator-node-status.txt';
	$handleout = fopen($filename, 'w') or die("can't open file: " . $filename);

	// load all store locator nodes
	$result = db_query("SELECT entity_id, field_store_number_value FROM field_data_field_store_number WHERE bundle = 'store_location'");

	$store_locator_map = array();
	$num_fixed = 0;
	$total = 0;

	$nodes = array();

	while ($obj = $result->fetchAssoc()) {
		//load node if id is less than 6 digits
		$storeId = $obj['field_store_number_value'];
		$nid = $obj['entity_id'];
		if( strlen($storeId) < 8 ) {
			$nodes[] = $nid;
		}
		$total++;
	}

	foreach ($nodes as $nid) {
		$num_fixed++;
		fwrite($handleout, $num_fixed . ': Store Id for node -> ' . $nid . ' is bad ' . "\n");
	}
	fwrite($handleout, 'Number of nodes with bad store id -> ' . $num_fixed . ' Total nodes -> ' . $total);
	watchdog('custom: Store Locator', 'custom_store_id_status() => Number of nodes with bad store id -> ' . $num_fixed, array(), WATCHDOG_INFO);

	fclose($handleout);
}

function custom_load_store_data($data_filename) {
	// get store mapping
	$curr_node_map = _custom_map_node_to_store();
	$new_store_list = _custom_get_clean_store_data($data_filename);
	
	//_custom_remove_old_store_data($new_store_list, $curr_node_map);
	_custom_update_store_data($new_store_list, $curr_node_map);
	
}

function _custom_remove_old_store_data($new_store_list, $curr_node_map) {
	$nid_delete_list = array();
	$new_store_id_list = array();
	
	foreach( $new_store_list as $row ) {
		$new_store_id_list[] = $row[0];
	}
	
	foreach (array_keys($curr_node_map) as $store_id ) {
		if(!in_array($store_id, $new_store_id_list)) {
			$nid_delete_list[] = $curr_node_map[$store_id];
		}
	}
	
	$nid_delete_batch = array();
	foreach ($nid_delete_list as $nid_delete) {
		$nid_delete_batch[] = $nid_delete;
		if( sizeof($nid_delete_batch) == 20 ) {
			watchdog('custom: Store Locator', '_custom_remove_old_store_data() => deleting stores -> ' . implode(",", $nid_delete_batch) , array(), WATCHDOG_DEBUG);
			node_delete_multiple($nid_delete_batch);
			unset($nid_delete_batch);	
			$nid_delete_batch = array();
		}
	}
	
	if( sizeof($nid_delete_batch ) > 0 ) {
		watchdog('custom: Store Locator', '_custom_remove_old_store_data() => deleting stores -> ' . implode(",", $nid_delete_batch) , array(), WATCHDOG_DEBUG);
		node_delete_multiple($nid_delete_batch);
	}
	
	watchdog('custom: Store Locator', '_custom_remove_old_store_data() => curr number of stores -> ' . sizeof($curr_node_map) . ', new number of stores -> ' . sizeof($new_store_id_list) . ', stores deleted -> ' . sizeof($nid_delete_list) , array(), WATCHDOG_INFO);
}

function _custom_get_store_map() {
	global $store_locator;
	$map = array();
	$file_path  = variable_get('file_public_path', conf_path() . '/files/');
    //$file_path = file_directory_temp();
	$filename = $file_path . '/storelocator/storelocator.map';
	if (($handle = fopen($filename, "r")) !== FALSE) {
		while (($row = fgetcsv($handle, 0, ",")) !== FALSE) {
			$map[intval($row[0])] = $row[1];
		}
	}
	
	fclose($handle);
	
	watchdog('custom: Store Locator', '_custom_get_store_map() => map size: ' . sizeof($map), array(), WATCHDOG_INFO);
	return $map;
}

function _custom_get_clean_store_data($name) {
	$data = array();
	$file_path  = variable_get('file_public_path', conf_path() . '/files/');
    //$file_path = file_directory_temp();
	$filename = $file_path . '/storelocator/data_out/' . $name;
	if (($handle = fopen($filename, "r")) !== FALSE) {
		while (($row = fgetcsv($handle, 0, ",")) !== FALSE) {
			$data[] = $row;
		}
		if( isset($data[0]) ) {
			unset($data[0]);
		}
	}
	watchdog('custom: Store Locator', '_custom_get_store_data() => file: ' . $name . ', rows read: ' . sizeof($data), array(), WATCHDOG_INFO);
	return $data;
}

function _custom_update_store_data($new_store_list, $curr_node_map) {
	$updated_count = 0;
	$new_count = 0;
	$total_count = 0;
	$unchanged_count = 0;
	$delete_count = 0;
	foreach ($new_store_list as $new_store) {
		$total_count++;
		$id = intval($new_store[0]);
		if(array_key_exists($id, $curr_node_map)) {
			// check if store should be deleted
			if( $new_store[12] == 'S' ) {
				node_delete($curr_node_map[$id]);
				$delete_count++;
			} else {
				$node_updated = _custom_update_store_locator($new_store, $curr_node_map[$id]);
				if( $node_updated ) {
					$updated_count++;
				} else {
					$unchanged_count++;
				}
			}
		} else {
			if( $new_store[12] != 'S' ) {
				_custom_add_store_locator($new_store);
				$new_count++;
			}
		}
	}
	
	watchdog('custom: Store Locator', '_custom_update_store_data() => total stores processed: ' . $total_count . ', nodes updated: ' . $updated_count . ', nodes created: ' . $new_count . ', nodes unchanged: ' . $unchanged_count . ', nodes deleted: ' . $delete_count, array(), WATCHDOG_INFO);
}

function _custom_update_store_locator($data, $nid) {	
	$node = node_load($nid);
	$values_changed = FALSE;
	//dpm($node);
	//dpm($data);
	
	//watchdog('custom: Store Locator','NODE: <pre>@placeholder_name</pre>',array('@placeholder_name' => print_r( $node, TRUE)),WATCHDOG_INFO);
	
	//check if we need to update node
	if( $node->title != $data[1] ) {
		$values_changed = TRUE;
		$node->title = $data[1];
	}
	if( sizeof($node->gsl_addressfield) && $node->gsl_addressfield['und'][0]['thoroughfare'] != $data[2] ) {
		$values_changed = TRUE;
		//watchdog('custom: Store Locator', '_custom_update_store_locator() => premise changed from #' . $node->gsl_addressfield['und'][0]['thoroughfare'] . '# to #'. $data[2] .  '#' , array(), WATCHDOG_INFO);
		$node->gsl_addressfield['und'][0]['thoroughfare'] = $data[2];
	}
	if( sizeof($node->gsl_addressfield) > 0 && $node->gsl_addressfield['und'][0]['premise'] != $data[3] ) {
		$values_changed = TRUE;
		//watchdog('custom: Store Locator', '_custom_update_store_locator() => premise changed from #' . $node->gsl_addressfield['und'][0]['premise'] . '# to #'. $data[3] .  '#' , array(), WATCHDOG_INFO);
		$node->gsl_addressfield['und'][0]['premise'] = $data[3];
	}
	if( sizeof($node->gsl_addressfield) > 0 && $node->gsl_addressfield['und'][0]['locality'] != $data[4] ) {
		$values_changed = TRUE;
		$node->gsl_addressfield['und'][0]['locality'] = $data[4];
		//watchdog('custom: Store Locator', '_custom_update_store_locator() => locality changed', array(), WATCHDOG_INFO);
	}
	if( sizeof($node->gsl_addressfield) > 0 && $node->gsl_addressfield['und'][0]['administrative_area'] != $data[5] ) {
		$values_changed = TRUE;
		$node->gsl_addressfield['und'][0]['administrative_area'] = $data[5];
		//watchdog('custom: Store Locator', '_custom_update_store_locator() => administrative_area changed', array(), WATCHDOG_INFO);
	}
	if( sizeof($node->gsl_addressfield) > 0 && $node->gsl_addressfield['und'][0]['postal_code'] != $data[6] ) {
		$values_changed = TRUE;
		$node->gsl_addressfield['und'][0]['postal_code'] = $data[6];
		//watchdog('custom: Store Locator', '_custom_update_store_locator() => postal_code changed', array(), WATCHDOG_INFO);
	}
	if( sizeof($node->gsl_addressfield) > 0 && $node->gsl_addressfield['und'][0]['country'] != $data[7] ) {
		$values_changed = TRUE;
		$node->gsl_addressfield['und'][0]['country'] = $data[7];
		//watchdog('custom: Store Locator', '_custom_update_store_locator() => country changed', array(), WATCHDOG_INFO);
	}
	if( sizeof($node->gsl_props_phone) > 0 && $node->gsl_props_phone['und'][0]['value'] != $data[8] ) {
		$values_changed = TRUE;
		$node->gsl_props_phone['und'][0]['value'] = $data[8];
		//watchdog('custom: Store Locator', '_custom_update_store_locator() => gsl_props_phone changed', array(), WATCHDOG_INFO);
	}
	if( sizeof($node->gsl_props_misc) > 0 && $node->gsl_props_misc['und'][0]['value'] != $data[9] ) {
		$values_changed = TRUE;
		$node->gsl_props_misc['und'][0]['value'] = $data[9];
		//watchdog('custom: Store Locator', '_custom_update_store_locator() => gsl_props_misc changed', array(), WATCHDOG_INFO);
	}
	if( sizeof($node->gsl_props_web) > 0 && $node->gsl_props_web['und'][0]['value'] != $data[10] ) {
		$values_changed = TRUE;
		$node->gsl_props_web['und'][0]['value'] = $data[10];
		//watchdog('custom: Store Locator', '_custom_update_store_locator() => gsl_props_web changed', array(), WATCHDOG_INFO);
	}	
	if( intval($data[11]) == 31 ) {
		$values_changed = TRUE;
		$node->gsl_feature_filter_list['und'][0]['value'] = 'dist';
	} else {
		if( count($node->gsl_feature_filter_list) > 0 ) {
			$values_changed = TRUE;
			$node->gsl_feature_filter_list = array();
			//watchdog('custom: Store Locator', '_custom_update_store_locator() => gsl_feature_filter_list reset', array(), WATCHDOG_INFO);
		}
	}
	
	if($values_changed) {
		node_save($node);
		return TRUE;
	} else {
		return FALSE;
	}
}

function _custom_add_store_locator($data) {
	//dpm('adding new node...');
	$values_changed = TRUE;
	$node = new stdClass();
	$node->type = 'store_location';
	node_object_prepare($node);
	$node->language = LANGUAGE_NONE;

	$node->field_store_number['und'][0]['value'] = $data[0];
	$node->title = $data[1];
	$node->gsl_addressfield['und'][0]['thoroughfare'] = $data[2];
	$node->gsl_addressfield['und'][0]['premise'] = $data[3];
	$node->gsl_addressfield['und'][0]['locality'] = $data[4];
	$node->gsl_addressfield['und'][0]['administrative_area'] = $data[5];
	$node->gsl_addressfield['und'][0]['postal_code'] = $data[6];
	$node->gsl_addressfield['und'][0]['country'] = $data[7];
	$node->gsl_props_phone['und'][0]['value'] = $data[8];
	$node->gsl_props_misc['und'][0]['value'] = $data[9];
	$node->gsl_props_web['und'][0]['value'] = $data[10];
	$node->log = t('Created by the Store Locator feed');

	node_save($node);
	//dpm($node);
}

function custom_views_query_alter(&$view, &$query) {
	
  if ($view->name == 'google_store_locator_json_export' && $view->current_display == 'page') {
      $query->where[0]['conditions'][0]['field'] = 'node.nid';
      if(count($view->args) > 0) {
      	$query->where[0]['conditions'][0]['value'] = _custom_get_close_stores($view->args[0], $view->args[1]);
      } else {
      	$query->where[0]['conditions'][0]['value'] = _custom_get_close_stores('32.929382', '-96.914477');
      }
      $query->where[0]['conditions'][0]['operator'] = 'in';
      //dpm($view);
  }
}

function _custom_get_close_stores($lat, $long, $dist = 50) {
	$stmt = "SELECT entity_id, ( 3959 * acos( cos( radians(" . $lat . ") ) * cos( radians( `gsl_geofield_lat` ) ) * cos( radians( `gsl_geofield_lon` ) - radians(".$long.") ) + sin( radians(".$lat.") ) * sin( radians( `gsl_geofield_lat` ) ) ) ) AS distance FROM field_data_gsl_geofield HAVING distance < " .$dist . " ORDER BY distance LIMIT 0 , 20;";
	$result = db_query($stmt);
	$nids = array();
	while ($obj = $result->fetchAssoc()) {
		$nids[] = $obj['entity_id'];
	}
	return $nids;
}

function custom_store_geo_location_backfill() {
	
	//get all store locator nodes that dont have lat or lon
	$num_updated = 0;
	$result = db_query("select nid from node left join field_data_gsl_geofield on nid = entity_id where entity_id is null and type = 'store_location'");
	while ($obj = $result->fetchAssoc()) {
		$nid = $obj['nid'];
		if( $num_updated < 200 ) {
			$node = node_load($nid);
			$node->original = array();
			watchdog('custom: Store Locator', "Getting geo location for store with name: " . $node->title . " and id: " . $node->field_store_number['und'][0]['value'], array(), WATCHDOG_INFO);
			node_save($node);
			$num_updated++;
		}		
	}
	watchdog('custom: Store Locator', "Number of nodes updated: " . $num_updated, array(), WATCHDOG_INFO);
	
}

?>