<?php

/**
 * Implementation of template preprocess for the view.
 */
function template_preprocess_views_bootstrap_tab_plugin_style(&$vars) {
  $view = &$vars['view'];
  $tab_field = $vars['options']['tab_field'];

  $vars['tab_type'] = $vars['options']['tab_type'];
  $vars['justified'] = $vars['options']['justified'];
  $vars['tab_group'] = $vars['options']['tab_group'];

  $group_by_tab_value_is_enabled = (boolean) $vars['tab_group'];
  $tab_value_to_row_key_map = array();

  // Get tabs.
  if (isset($view->field[$tab_field])) {
    foreach ($vars['rows'] as $orig_row_key => $row) {
      $tab_field_value = $view->style_plugin->get_field($orig_row_key, $tab_field);

      if ($group_by_tab_value_is_enabled && isset($tab_value_to_row_key_map[$tab_field_value])) {
        $new_row_key = $tab_value_to_row_key_map[$tab_field_value];
      }
      else {
        $new_row_key = $tab_value_to_row_key_map[$tab_field_value] = $orig_row_key;
      }

      $vars['tabs'][$new_row_key] = $tab_field_value;

      if ($group_by_tab_value_is_enabled) {
        if(array_key_exists($new_row_key, $vars['rows'])){
          $vars['rows'][$new_row_key] = array();
        }
        //if (!is_array($vars['rows'][$new_row_key])) {
          //$vars['rows'][$new_row_key] = array();
        //}
        $vars['rows'][$new_row_key][] = '<div class="tab-content-item">' . $row . '</div>';
        unset($vars['rows'][$orig_row_key]);
      }
    }

    // The template expects a scalar value, so items within each tab are flattened to a string.
    if ($group_by_tab_value_is_enabled) {
      foreach ($vars['rows'] as &$r) {
        $r = implode("\n", $r);
      }
    }
  }

  $keys = array_keys($vars['rows']);
  $vars['first_key'] = reset($keys);
}
