(function ($) {

  // Moved the logic for categories to moda-msf.js
    
  $(document).ready(function(){
    // Hide Header on on scroll down
    var didScroll;
    var lastScrollTop = 0;
    var delta = 5;
    var navbarHeight = $('#sticky_nav-container').outerHeight() + $('#page-header').outerHeight();

    $(window).scroll(function(event){
        didScroll = true;
    });

    setInterval(function() {
        if (didScroll) {
            hasScrolled();
            didScroll = false;
        }
    }, 250);

    function hasScrolled() {
        var st = $(this).scrollTop();

        // Make sure they scroll more than delta
        if(Math.abs(lastScrollTop - st) <= delta)
            return;

        // If they scrolled down and are past the navbar, add class .nav-up.
        // This is necessary so you never see what is "behind" the navbar.
        if (st > lastScrollTop && st > navbarHeight){
            // Scroll Down
            $('#sticky_nav-container').removeClass('sticky_nav-up').addClass('sticky_nav-down');
        } else {
            // Scroll Up
            if(st + $(window).height() < $(document).height()) {
                $('#sticky_nav-container').removeClass('sticky_nav-down').addClass('sticky_nav-up');
            }
        }

        lastScrollTop = st;
    }
    
    $('#edit-custom-search-blocks-form-2--2').click(function () {
      $('#edit-custom-search-blocks-form-2--2').val('');
    });
    
    $('#edit-custom-search-blocks-form-3--2').focus(function () {
        $(this).data('placeholder', $(this).attr('placeholder'))
               .attr('placeholder', '');
    }).blur(function () {
        $(this).attr('placeholder', $(this).data('placeholder'));
    });
    
    
  });
  
  // React to the gslReady event.
  $(document).bind('gslReady', function(event) {

    var orig_parseStores_ = Drupal.GSL.dataSource.prototype.parseStores_ ;
    
    Drupal.GSL.dataSource.prototype.parseStores_ = function(json) {
      console.log('parseStores_');
      var stores = orig_parseStores_(json);

      for ( var storeIndex in stores) {
        var distance = new storeLocator.Feature('1', 'Distance: ' + (stores[storeIndex].distanceTo(Drupal.GSL.currentMap.center) * 0.621371).toFixed(2) + ' miles');
        stores[storeIndex].getFeatures().add(distance);
      }

      return stores;
    };
  });

  
  
  /* not using anymore as of Nov 2019; pulling in blog posts using Similar Terms */
  $.fn.FeedEk = function (opt) {
        var def = $.extend({
            MaxCount: 5,
            ShowDesc: true,
            ShowPubDate: true,
            DescCharacterLimit: 0,
            TitleLinkTarget: "_blank",
            DateFormat: "",
            DateFormatLang:"en"
        }, opt);
        
        var id = $(this).attr("id"), i, s = "", dt;
        $("#" + id).empty();
        if (def.FeedUrl == undefined) return;       
        $("#" + id).append('<i class="fa fa-spinner fa-spin fa-lg"></i>');

        var YQLstr = 'SELECT channel.item FROM feednormalizer WHERE output="rss_2.0" AND url ="' + def.FeedUrl + '" LIMIT ' + def.MaxCount;

        $.ajax({
            url: "https://query.yahooapis.com/v1/public/yql?q=" + encodeURIComponent(YQLstr) + "&format=json&diagnostics=false&callback=?",
            dataType: "json",
            success: function (data) {
                $("#" + id).empty();
                if (!(data.query.results.rss instanceof Array)) {
                    data.query.results.rss = [data.query.results.rss];
                }
                $.each(data.query.results.rss, function (e, itm) {
                    s += '<li><div class="itemTitle"><h3><a href="' + itm.channel.item.link + '" target="' + def.TitleLinkTarget + '" >' + itm.channel.item.title + '</a></h3></div>';
                    
                    if (def.ShowPubDate){
                        dt = new Date(itm.channel.item.pubDate);
                        s += '<div class="itemDate">';
                        if ($.trim(def.DateFormat).length > 0) {
                            try {
                                moment.lang(def.DateFormatLang);
                                s += moment(dt).format(def.DateFormat);
                            }
                            catch (e){s += dt.toLocaleDateString();}                            
                        }
                        else {
                            s += dt.toLocaleDateString();
                        }
                        s += '</div>';
                    }
					
					if( itm.channel.item.thumbnail ) {
                        s += '<div class="itemImage"><img src="' + itm.channel.item.thumbnail.url + '"/></div>';
                    }

                    if (def.ShowDesc) {
                        var desc = "";
                        if( itm.channel.item.description ) {
                            desc = itm.channel.item.description;
                        }
                        if( itm.channel.item.summary) {
                            desc = itm.channel.item.summary.content;
                        }
                        s += '<div class="itemContent">';
                         if (def.DescCharacterLimit > 0 && desc.length > def.DescCharacterLimit) {
                            s += desc.substring(0, def.DescCharacterLimit) + '...';
                        }
                        else {
                            s += desc;
                         }
                         s += '</div>';
                    }
                });
                $("#" + id).append('<ul class="feedEkList">' + s + '</ul>');
            }
        });
    };
  
})(jQuery);;