<?php 

function unitednotionsTablet_menu_local_tasks(&$vars) {
  $output = '';
  if (!empty($vars['primary'])) {
    //$vars['primary']['#prefix'] = '<h2 class="element-invisible">' . t('Primary tabs') . '</h2>';
    $vars['primary']['#prefix'] = '<div data-role="navbar"><ul data-mini="true" class="tabs primary">';
    //$vars['primary']['#prefix'] .= '<li><a href="/admin">Administer Site</li>';
    $vars['primary']['#suffix'] = '</ul></div>';
    $output .= drupal_render($vars['primary']);
  }
  if (!empty($vars['secondary'])) {
    $vars['secondary']['#prefix'] = '<h2 class="element-invisible">' . t('Secondary tabs') . '</h2>';
    $vars['secondary']['#prefix'] .= '<div data-role="navbar"><ul class="tabs secondary">';
    $vars['secondary']['#suffix'] = '</ul></div>';
    $output .= drupal_render($vars['secondary']);
  }

  return $output;
}

function unitednotionsTablet_preprocess_html(&$vars) {
	global $user;
			
	$vars['viewport'] = implode(',', mobile_jquery_get_viewport());
	
	$css_options = array(
			'type' => 'file',
			'group' => CSS_THEME,
			'every_page' => TRUE,
			'media' => 'all',
			'preprocess' => FALSE,
	);
	$js_options = array(
			'type' => 'file',
			'scope' => 'header',
			'group' => JS_THEME + 100,
			'every_page' => TRUE,
			'preprocess' => TRUE,
			'cache' => TRUE,
			'defer' => FALSE,
	);
	
	$js_options1 = array(
			'type' => 'file',
			'scope' => 'header',
			'group' => JS_THEME,
			'every_page' => TRUE,
			'preprocess' => FALSE,
			'cache' => TRUE,
			'defer' => FALSE,
	);
	
	drupal_add_css('//code.jquery.com/mobile/1.3.1/jquery.mobile.structure-1.3.1.min.css', array_merge($css_options, array('weight' => 100)));
	drupal_add_css(drupal_get_path('theme', 'unitednotionsTablet') .'/css/unitednotions-jquery-mobile.min.css', array_merge($css_options, array('weight' => 100)));
	
	//drupal_add_js('//code.jquery.com/jquery-1.9.1.min.js', array_merge(array('group' => -100), array('weight' => -20)));
	if( isset($user) && $user->uid > 0 || arg(0) == 'user') {
		drupal_add_js(drupal_get_path('theme', 'unitednotionsTablet') . '/js/init.admin.js', array_merge($js_options, array('weight' => 101)));
	} else {
		//drupal_add_js(drupal_get_path('theme', 'unitednotionsTablet') . '/js/init.js', array_merge($js_options, array('weight' => 101)));
	}
	drupal_add_js('//code.jquery.com/mobile/1.3.1/jquery.mobile-1.3.1.min.js', array_merge($js_options1, array('weight' => 101)));

	drupal_add_js(drupal_get_path('theme', 'unitednotionsTablet') . '../../../libraries/jquery.flexslider/jquery.flexslider-min.js', array_merge($js_options, array('weight' => 102)));
	drupal_add_js(drupal_get_path('theme', 'unitednotionsTablet') . '../../../libraries/jquery-share/jquery.share.js', array_merge($js_options, array('weight' => 102)));
	drupal_add_js('https://www.google.com/jsapi', array_merge($js_options1, array('weight' => 102)));
	drupal_add_js(drupal_get_path('theme', 'unitednotionsTablet') . '../../../libraries/wookmark/jquery.wookmark.min.js', array_merge($js_options, array('weight' => 102)));
	drupal_add_js(drupal_get_path('theme', 'unitednotionsTablet') . '../../../libraries/wookmark/libs/jquery.imagesloaded.js', array_merge($js_options, array('weight' => 102)));
	drupal_add_js(drupal_get_path('theme', 'unitednotionsTablet') . '../../../libraries/js/jquery.cookie.js', array_merge($js_options, array('weight' => 102)));
	
	drupal_add_js(drupal_get_path('theme', 'unitednotionsTablet') . '/js/tablet.js', array_merge($js_options, array('weight' => 103)));
	drupal_add_js(drupal_get_path('theme', 'unitednotionsTablet') . '../../../modules/custom/js/feed.js', array_merge($js_options, array('weight' => 103)));
	
	$vars['styles'] = drupal_get_css();

}

function unitednotionsTablet_library_alter(&$javascript, $module) {
	//unset($javascript['jquery']['js']['misc/jquery.js']);
	//dpm($javascript);
	//unset($javascript['http://code.jquery.com/jquery-1.5.2.min.js']);
}

function unitednotionsTablet_form_alter(&$form, &$form_state, $form_id) {
	//dsm($form);

	if( $form_id == 'user_login' ) {
		$form['actions']['submit']['#attributes']['data-ajax'] = 'false';
	}
}

?>